/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Contributor(s) : Santhosh N, Girish A J, P R Subramanya 
#include <pwrap.h>

pw_widget toplevel, label;

Bool bcallback(pw_widget widget, pw_event event)
{
	if(!strcmp(widget->tag, "L")) {
#ifdef __arm__
		pw_alchemy_command(toplevel, AC_CMD_SET_ROTATION, "3");
#endif
	}
	
	if(!strcmp(widget->tag, "R")) {
#ifdef __arm__
		pw_alchemy_command(toplevel, AC_CMD_SET_ROTATION, "1");
#endif
	}
	
	if(!strcmp(widget->tag, "T")) {
#ifdef __arm__
		pw_alchemy_command(toplevel, AC_CMD_SET_ROTATION, "0");
#endif
	}
	
	if(!strcmp(widget->tag, "B")) {
#ifdef __arm__
		pw_alchemy_command(toplevel, AC_CMD_SET_ROTATION, "2");
#endif
	}
	
	if(!strcmp(widget->tag, "D")) {
		int orient = pw_get_display_orientation(toplevel);
		char dir[256];
		if(orient==PW_ORIENT_TOP) strcpy(dir, "Top");
		if(orient==PW_ORIENT_BOTTOM) strcpy(dir, "Bottom");
		if(orient==PW_ORIENT_LEFT) strcpy(dir, "Left");
		if(orient==PW_ORIENT_RIGHT) strcpy(dir, "Right");
		pw_set_text(label, "%d x %d, %s", pw_get_display_width(toplevel),
									pw_get_display_height(toplevel), dir);
	}

	return False;
}

int main(int ac, char **av)
{
	pw_widget b1, b2, b3, b4, b5;
	
	pw_init(PW_SUPPORT_ALCHEMY);

     toplevel = pw_create_window(240, 270, PW_TITLE, "Example", PW_CONFIG_END);

	b1 = pw_create_button(toplevel, 20, 10, 40, 25, PW_NA);
	pw_set_text(b1, "Left");
	pw_set_font(b1, PW_SMALL_FONT);
	pw_set_callback(b1, PW_BUTTON_RELEASE_EVENT, bcallback);
	pw_set_tag(b1, "L");
	
	b2 = pw_create_button(toplevel, 70, 10, 40, 25, PW_NA);
	pw_set_text(b2, "Right");
	pw_set_font(b2, PW_SMALL_FONT);
	pw_set_callback(b2, PW_BUTTON_RELEASE_EVENT, bcallback);
	pw_set_tag(b2, "R");
	
	b3 = pw_create_button(toplevel, 120, 10, 40, 25, PW_NA);
	pw_set_text(b3, "Top");
	pw_set_font(b3, PW_SMALL_FONT);
	pw_set_callback(b3, PW_BUTTON_RELEASE_EVENT, bcallback);
	pw_set_tag(b3, "T");
	
	b4 = pw_create_button(toplevel, 170, 10, 50, 25, PW_NA);
	pw_set_text(b4, "Bottom");
	pw_set_font(b4, PW_SMALL_FONT);
	pw_set_callback(b4, PW_BUTTON_RELEASE_EVENT, bcallback);
	pw_set_tag(b4, "B");
	
	b5 = pw_create_button(toplevel, 50, 50, 140, 25, PW_NA);
	pw_set_text(b5, "Update Dimensions");
	pw_set_font(b5, PW_SMALL_FONT);
	pw_set_callback(b5, PW_BUTTON_RELEASE_EVENT, bcallback);
	pw_set_tag(b5, "D");

	label = pw_create_label(toplevel, 30, 90, 180, 25, 
								PW_FONT, PW_SMALL_FONT, 
								PW_JUSTIFY, PW_JUSTIFY_CENTER,
								PW_NA);
	int orient = pw_get_display_orientation(toplevel);
	char dir[256];
	if(orient==PW_ORIENT_TOP) strcpy(dir, "Top");
	if(orient==PW_ORIENT_BOTTOM) strcpy(dir, "Bottom");
	if(orient==PW_ORIENT_LEFT) strcpy(dir, "Left");
	if(orient==PW_ORIENT_RIGHT) strcpy(dir, "Right");
	pw_set_text(label, "%d x %d, %s", pw_get_display_width(toplevel),
								pw_get_display_height(toplevel), dir);

	pw_eventloop();

     pw_exit();
}
