/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Contributor(s) : Santhosh N, Girish A J, P R Subramanya 
#include <pwrap.h>

int tx, ty;

Bool bcallback_press(px_widget *widget, px_event *event)
{
	pw_grab(widget);
	pw_raise(widget);
	tx = event->x;
	ty = event->y;

	return False;
}

Bool bcallback_release(px_widget *widget, px_event *event)
{
	pw_ungrab();
	return False;
}

Bool bcallback_motion(px_widget *widget, px_event *event)
{
	pw_set_position(widget, widget->x + event->x - tx, widget->y + event->y - ty);

	pw_flush_eventloop();

	return False;
}

int main(int ac, char **av)
{
	pw_widget toplevel, button1, button2;
	
	pw_init(PW_SUPPORT_ALCHEMY);

     toplevel = pw_create_window(240, 270, PW_TITLE, "Example", PW_NA);
	button1 = pw_create_button(toplevel, 10, 10, 50, 30, 
							PW_TEXT, "B-1", 
							PW_TAG, "B-1", 
							PW_BORDER, PW_RECTANGLE_BORDER,
							PW_CALLBACK, PW_BUTTON_PRESS_EVENT, bcallback_press,
							PW_CALLBACK, PW_BUTTON_RELEASE_EVENT, bcallback_release,
							PW_CALLBACK, PW_MOTION_EVENT, bcallback_motion,
							PW_CONFIG_END);
	
	button2 = pw_create_button(toplevel, 80, 80, 50, 30, 
							PW_TEXT, "B-2", 
							PW_TAG, "B-2", 
							PW_BORDER, PW_RECTANGLE_BORDER,
							PW_CALLBACK, PW_BUTTON_PRESS_EVENT, bcallback_press,
							PW_CALLBACK, PW_BUTTON_RELEASE_EVENT, bcallback_release,
							PW_CALLBACK, PW_MOTION_EVENT, bcallback_motion,
							PW_CONFIG_END);

	pw_eventloop();

     pw_exit();
}
