/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Contributor(s) : Santhosh N, Girish A J, P R Subramanya 
#include <pwrap.h>

#define NUM 15

pw_widget toplevel, b1, b2, l1, l2, l3;
multi_column *mc;

void clear_multicol_listbox()
{
	int i, nrows;

	nrows = mc->get_no_of_rows(mc);

	for(i=0; i<nrows; i++) {
		mc->remove_row(mc, 0);
	}
}

void load_multicol_listbox()
{
	int i;

	for(i=0; i<NUM; i++) {
		pw_widget row, col1, col2, col3;
		char str[20];

		mc->add_row(mc, i);
		row = mc->get_row(mc, i);

		sprintf(str, "%d,%d", i, 0);
		col1 = pw_create_label(row, 0, 0, 10, 20, PW_TEXT, str, PW_NA);
		mc->add_child(mc, col1, i, 0);

		sprintf(str, "%d, %d", i, 1);
		col2 = pw_create_label(row, 0, 0, 10, 20, PW_TEXT, str, PW_NA);
		mc->add_child(mc, col2, i, 1);

		sprintf(str, "%d, %d", i, 2);
		col3 = pw_create_label(row, 0, 0, 10, 20, PW_TEXT, str, PW_NA);
		mc->add_child(mc, col3, i, 2);
	}
}

Bool b1callback(pw_widget widget, pw_event event)
{
	clear_multicol_listbox();
	load_multicol_listbox();

	return False;
}

Bool b2callback(pw_widget widget, pw_event event)
{
	clear_multicol_listbox();

	return False;
}

int main(int ac, char **av)
{
	pw_init(0);

	// Create Toplevel
     toplevel = pw_create_window(240, 270, PW_TITLE, "Example", PW_CONFIG_END);

	// Create Multi Column
	mc = multi_column_create(toplevel, 10, 10, 220, 220, 3);
	pw_update(mc->mainframe, 1);

	l1 = pw_create_label(mc->header, 0, 0, 1, 1, PW_TEXT, "Subject", PW_CONFIG_END);
	mc->set_column_title(mc, l1, 0);
	
	l2 = pw_create_label(mc->header, 0, 0, 1, 1, PW_TEXT, "Marks", PW_CONFIG_END);
	mc->set_column_title(mc, l2, 1);
	
	l3 = pw_create_label(mc->header, 0, 0, 1, 1, PW_TEXT, "Grade", PW_CONFIG_END);
	mc->set_column_title(mc, l3, 2);

	clear_multicol_listbox();
	load_multicol_listbox();

	// Button
	b1 = pw_create_button(toplevel, 180, 240, 50, 25, PW_TEXT, "Reload", 
							PW_CALLBACK, PW_BUTTON_RELEASE_EVENT, b1callback,
							PW_CONFIG_END);
	
	b2 = pw_create_button(toplevel, 120, 240, 50, 25, PW_TEXT, "Clear", 
							PW_CALLBACK, PW_BUTTON_RELEASE_EVENT, b2callback,
							PW_CONFIG_END);
	
	pw_eventloop();

     pw_exit();
}
