/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Contributor(s) : Santhosh N, Girish A J, P R Subramanya 
#include <pwrap.h>

pw_widget toplevel, progressbar, button, label;
pw_timer timer;
int progress=0;

Bool timer_callback()
{
	progress+=10;

	pw_progressbar_setvalue(progressbar, progress-1);

	if(progress==100) {
		pw_destroy_timer(timer);
		pw_enable(button);
	} else {
		pw_disable(button);
	}
	
	pw_set_text(label, "%d %%", progress);

	return True;
}

Bool bcallback(pw_widget widget, pw_event event)
{
	progress = 0;

	timer = pw_create_timer(500000, True, timer_callback, NULL, NULL);

	return False;
}

int main(int ac, char **av)
{
	pw_init(0);

     toplevel = pw_create_window(240, 270, PW_TITLE, "Example", PW_CONFIG_END);

	progressbar = pw_create_progressbar(toplevel, 40, 40, 160, 25, PW_NA);
	pw_draw_rectangle(toplevel, 38, 38, 162, 29);

	label = pw_create_label(toplevel, 70, 70, 100, 40, 
							PW_JUSTIFY, PW_JUSTIFY_CENTER, 
							PW_FONT, PW_BOLD_FONT,
							PW_TEXT, "0 %%", 
							PW_NA);
	
	button = pw_create_button(toplevel, 50, 130, 140, 30,
							PW_TEXT, "Show progress",
							PW_FONT, PW_BOLD_FONT,
							PW_CALLBACK, PW_BUTTON_RELEASE_EVENT, bcallback,
							PW_NA);
	
	pw_eventloop();

     pw_exit();
}
