/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Contributor(s) : Santhosh N, Girish A J, P R Subramanya 
#include<pwrap.h>

pw_widget toplevel, tab, text, button1, button2, page, sketch;
int fg;

Bool b1_callback(pw_widget widget, pw_event event)
{
	if(fg) {
		fg = 0;
		pw_set_wrap(text, PW_NO_WRAP);
	} else {
		fg = 1;
		pw_set_wrap(text, PW_WORD_WRAP);
	}

	return False;
}

Bool b2_callback(pw_widget widget, pw_event event)
{
	pw_sketch_clear(sketch);
	return False;
}

int main()
{
	pw_init(0);

	toplevel = pw_create_window(240, 270, PW_TITLE, "Hello", PW_NA);
	pw_set_bgcolor(toplevel, "#eeeeee");

	tab = pw_create_tab(toplevel, 10, 10, 220, 250, PW_NA);
	
	page = pw_tab_add_page(tab, "Text", NULL);
	text = pw_create_textbox(page, 10, 10, 190, 150, PW_NA);
	button1 = pw_create_button(page, 60, 180, 80, 25, PW_TEXT, "Wrap",
							PW_CALLBACK, PW_BUTTON_RELEASE_EVENT, b1_callback,
							PW_NA);
	pw_set_bgcolor(page, "#eeeeee");

	page = pw_tab_add_page(tab, "Sketch", NULL);
	sketch = pw_create_sketch(page, 10, 10, 185, 150, PW_NA); 
	button2 = pw_create_button(page, 60, 180, 80, 25, PW_TEXT, "Clear", 
							PW_CALLBACK, PW_BUTTON_RELEASE_EVENT, b2_callback,
							PW_NA);
	pw_set_bgcolor(page, "#eeeeee");
	
	page = pw_tab_add_page(tab, "Entry", NULL);
	pw_create_entry(page, 10, 20, 160, 20, PW_NA);
	pw_create_entry(page, 10, 70, 160, 20, PW_NA);
	pw_create_entry(page, 10, 120, 160, 20, PW_NA);
	pw_set_bgcolor(page, "#eeeeee");

	pw_tab_raise_page(tab, 0);
	
	pw_focus(text);
	
	pw_eventloop();

	pw_exit();
}
