/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author : Saugata Das
// Basic functions
#include "pwrap.h"
#include "pdefs.h"

struct __pw_global_vars _pw_global_vars;

int pw_init(unsigned flags)
{
	pw_flags = flags;
	
	pdisplay = display_get_display();

     if(pdisplay->open_display(pdisplay, (char *)getenv("DISPLAY"))) {
		xdisplay = display_get_Xdisplay();
		screen = DefaultScreen(xdisplay);
	
		// Process few pw_init flags
		display_register_wm_protocol(pdisplay, "WM_PROTOCOLS");
		display_register_wm_protocol(pdisplay, "WM_DELETE_WINDOW");
		if(pw_flags&PW_SUPPORT_ALCHEMY) {
			display_register_wm_protocol(pdisplay, "_AC_BUTTON_RETRACTBAR_REL");
			display_register_wm_protocol(pdisplay, "_AC_BUTTON_UP_REL");
			display_register_wm_protocol(pdisplay, "_AC_BUTTON_TICK_REL");
			display_register_wm_protocol(pdisplay, "_AC_BUTTON_NEXTPAGE");
			display_register_wm_protocol(pdisplay, "_AC_BUTTON_NEXTPAGE_REL");
			display_register_wm_protocol(pdisplay, "_AC_BUTTON_PREVPAGE");
			display_register_wm_protocol(pdisplay, "_AC_BUTTON_PREVPAGE_REL");
			display_register_wm_protocol(pdisplay, "_AC_BUTTON_EMAIL_REL");
			display_register_wm_protocol(pdisplay, "_AC_BUTTON_PRINTER_REL");
		}
		if(pw_flags&PW_SUPPORT_ROCKER) {
			display_register_wm_protocol(pdisplay, "_AC_BUTTON_ROCKER_UP");
			display_register_wm_protocol(pdisplay, "_AC_BUTTON_ROCKER_UP_REL");
			display_register_wm_protocol(pdisplay, "_AC_BUTTON_ROCKER_DOWN");
			display_register_wm_protocol(pdisplay, "_AC_BUTTON_ROCKER_DOWN_REL");
			display_register_wm_protocol(pdisplay, "_AC_BUTTON_ROCKER_SELECT");
			display_register_wm_protocol(pdisplay, "_AC_BUTTON_ROCKER_SELECT_REL");
		}
		if(pw_flags&PW_SUPPORT_ACCELEROMETER) {
			display_register_wm_protocol(pdisplay, "_AC_ACCEL_RIGHT_FLICK");
			display_register_wm_protocol(pdisplay, "_AC_ACCEL_LEFT_FLICK");
			display_register_wm_protocol(pdisplay, "_AC_ACCEL_TOP_FLICK");
			display_register_wm_protocol(pdisplay, "_AC_ACCEL_BOTTOM_FLICK");
			display_register_wm_protocol(pdisplay, "_AC_ACCEL_RIGHT_EXTREME");
			display_register_wm_protocol(pdisplay, "_AC_ACCEL_LEFT_EXTREME");
		}
	
          return 0;
	} else {
          return 1;
	}
}

void pw_exit()
{
	if(toplevel_win)
		XFreeGC(xdisplay, draw_gc);

     if(pdisplay)
          display_destroy();
}

void pw_eventloop()
{
     px_eventloop *eloop = eventloop_get_eventloop();
     eloop->loop(eloop);
}
