/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author : Saugata Das
// Eventloop handling functions
#include "pwrap.h"
#include "pdefs.h"

void pw_handle_one_event()
{
	px_eventloop *eloop = eventloop_get_eventloop();

	eloop->do_one_event(eloop);	
}

void pw_stop_eventloop()
{
     px_eventloop *eloop = eventloop_get_eventloop();

     eloop->exit(eloop);
}

void pw_flush_eventloop()
{
	XEvent xev, xev_copy;
	int fg=0;
	
	while(XPending(xdisplay)) {
		XNextEvent(display_get_Xdisplay(), &xev);
		if(!fg && xev.type==MotionNotify) {
			fg = 1;
			xev_copy = xev;
		}
		if(xev.type!=MotionNotify) {
			fg = 1;
			xev_copy = xev;
			break;
		}
	}

	if(fg)
		XPutBackEvent(display_get_Xdisplay(), &xev_copy);
}

int pw_event_getx(pw_event event)
{
	return event->x;
}

int pw_event_gety(pw_event event)
{
	return event->y;
}

unsigned char pw_event_getchar(pw_event event)
{
	return event->ch;
}

void *pw_event_callback_parameter(pw_event event)
{
	return event->private_data;
}

pw_timer pw_create_timer(unsigned long time, int repeat, Bool (*callback)(void*, void*), void *arg1, void *arg2)
{
     px_eventloop *eloop = eventloop_get_eventloop();
	
	return eventloop_add_timer(eloop, 0, time, callback, arg1, arg2, repeat);
}

void pw_destroy_timer(pw_timer timer)
{
	px_eventloop *eloop = eventloop_get_eventloop();

	eventloop_delete_timer(eloop, timer);

	timer = NULL;
}
