/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author : Saugata Das
// Image functions
#include "pwrap.h"
#include "pdefs.h"

pw_pixmap pw_create_pixmap_from_file(const char *file, ...)
{
	px_pixmap *pixmap=NULL;
	pw_image image;
	int ret;
	char *txt=NULL;
	va_list ap;
	
	va_start(ap, file);
	txt = _pw_my_printf(file, ap);
	va_end(ap);

	ret = pimg_load(txt, display_get_Xdisplay(), &image, DITHER);

	if(ret>=0) {
		pixmap = (px_pixmap*)malloc(sizeof(px_pixmap));
		image_initialize_pixmap(pixmap);
		image_create_pixmap(toplevel_win->win, pixmap, image->width, image->height);
		image_copy_image(toplevel_win->win, pixmap, image);
		pimg_free(&image);
	}

	if(txt)
		free(txt);

	return pixmap;
}

void pw_destroy_pixmap(pw_pixmap pixmap)
{
	image_destroy(pixmap);
}

int pw_get_pixmap_width(pw_pixmap pixmap)
{
	return (pixmap) ? pixmap->w : -1;
}

int pw_get_pixmap_height(pw_pixmap pixmap)
{
	return (pixmap) ? pixmap->h : -1;
}

void pw_draw_pixmap(pw_pixmap src_pixmap, pw_widget dest_widget,  
				int src_x, int src_y, int width, int height, int dest_x, int dest_y)
{
	image_copy_part_of_pixmap(dest_widget->win, &(dest_widget->backing_store), 
							src_pixmap, src_x, src_y, dest_x, dest_y, width, height);
	XClearArea(display_get_Xdisplay(), dest_widget->win, dest_x, dest_y, width, height, True);
}
